#!/usr/bin/env python
#
# --------------------------------------------------------------
#scan_database.py: a simple script to wrape Bcheck for scaning the large databse
#The outputs for each org directory:
#time cost; Bcheck log; rnpB.fa; rnpB.ss
#
# Dilmurat Yusuf 
# Institute for Theoretical Chemistry of the University of Vienna
#
# dilmurat@tbi.univie.ac.at
# --------------------------------------------------------------
#
#
# Current release: 0.1 (June 2009)
# Copyright (C) 2009  Dilmurat Yusuf  
#
#
#scan_database.py [options] target_database.dir
#target_database.dir format: "#org  dir/org/*fna"
#
def Usage ():
        print "scan_database.py  0.1\n" 
	print "Usage: scan_database.py [options] target_database.dir"
        print "target_database.dir format: '#org  dir/org/*fna'"
	print
        
	print "Search method:"
	print "-c      : with only covariance model"
	print "Default : with both descriptor and covariance model"
	print
	
	print "Domain options for fasta input: "
	print "-B : Bacteria"
	print "-A : Archaea"
	print "-E : Eukaryote"
	print "-f : Fungi(updating models!)"
	print
	sys.exit(0)

def domain_opt(optlist):
	cnt = 0
	
	for opt in optlist:
	    if  '-A' == opt[0]:
		domain = '-A'
		cnt += 1
	    if  '-B' == opt[0]:
		domain = '-B'
		cnt += 1
            if '-E' == opt[0]:
		domain = '-E'
		cnt += 1
	    if '-f' == opt[0]:
		domain = '-f'
	        cnt += 1 
		 
	if cnt == 0:
	    print "Please specify a domain option!\n"
	    Usage()
	elif cnt > 1:
	    print "At one time, no more than 1 domain option!\n"
	    Usage()
	
	return domain    

def opt(optlist):
    method = ''
    
    for opt in optlist:
	if '-c'	== opt[0]:
	        method = "-c" 
    return method

if __name__ ==  "__main__":
    import commands, sys, getopt
    
    try:
	optlist, dirs = getopt.getopt(sys.argv[1:],'BAEfc')
    except getopt.GetoptError, Error:
	print Error
	print
	Usage()
        
    if optlist == [] and input == []:
	Usage()    
    
    domain = domain_opt(optlist)
    method = opt(optlist)
    
    for d in dirs:
        #if given the multiple dir files
        for dir in open(d).readlines():	
	    if dir[0] == "#": 	
		dir = dir.split()
		org = dir[0][1:]
		commands.getoutput("mkdir %s" % org)
		print "#"+org
		print commands.getoutput("/usr/bin/time -o %s/time Bcheck %s %s --ss --fa -o %s/ %s  > %s/Bcheck.log" % (org,domain,method,org,dir[1],org))
		